"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var groestlcoinJSMessage = require("../../dependencies/src/groestlcoinjs-message-2.1.0/index");
var ProtocolSymbols_1 = require("../../utils/ProtocolSymbols");
var BitcoinProtocol_1 = require("../bitcoin/BitcoinProtocol");
var BitcoinCryptoClient_1 = require("../bitcoin/BitcoinCryptoClient");
var GroestlcoinProtocolOptions_1 = require("./GroestlcoinProtocolOptions");
var GroestlcoinProtocol = /** @class */ (function (_super) {
    __extends(GroestlcoinProtocol, _super);
    function GroestlcoinProtocol(options) {
        if (options === void 0) { options = new GroestlcoinProtocolOptions_1.GroestlcoinProtocolOptions(); }
        var _this = _super.call(this, options) || this;
        _this.options = options;
        _this.symbol = 'GRS';
        _this.name = 'Groestlcoin';
        _this.marketSymbol = 'grs';
        _this.feeSymbol = 'grs';
        _this.feeDefaults = {
            low: '0.00002',
            medium: '0.00004',
            high: '0.00005'
        };
        _this.decimals = 8;
        _this.feeDecimals = 8;
        _this.identifier = ProtocolSymbols_1.MainProtocolSymbols.GRS;
        _this.units = [
            {
                unitSymbol: 'GRS',
                factor: '1'
            },
            {
                unitSymbol: 'mGRS',
                factor: '0.0001'
            },
            {
                unitSymbol: 'Satoshi',
                factor: '0.00000001'
            }
        ];
        _this.supportsHD = true;
        _this.standardDerivationPath = "m/44'/17'/0'";
        _this.addressValidationPattern = '^([F3][a-km-zA-HJ-NP-Z1-9]{33}|grs1[a-zA-HJ-NP-Z0-9]{39})$';
        _this.addressPlaceholder = 'Fdb...';
        _this.cryptoClient = new BitcoinCryptoClient_1.BitcoinCryptoClient(_this, groestlcoinJSMessage);
        return _this;
    }
    return GroestlcoinProtocol;
}(BitcoinProtocol_1.BitcoinProtocol));
exports.GroestlcoinProtocol = GroestlcoinProtocol;
//# sourceMappingURL=GroestlcoinProtocol.js.map