/// <reference types="node" />
export declare class AES {
    readonly AES_KEY_SIZE: number;
    readonly KEY_DERIVATION_ITERATION_COUNT: number;
    readonly ALGORITHM: 'aes-256-gcm';
    readonly encoding: 'base64' | 'hex';
    constructor(AES_KEY_SIZE?: number, KEY_DERIVATION_ITERATION_COUNT?: number, ALGORITHM?: 'aes-256-gcm', encoding?: 'base64' | 'hex');
    encryptString(plainText: string, privateKey: Buffer): Promise<string>;
    decryptString(encryptedValue: string, privateKey: Buffer): Promise<string>;
    private deriveKeyFromPrivateKey;
}
